import { G6 } from '@antv/graphin';
import * as React from 'react';
var PatternGraph = function PatternGraph(props) {
  var pattern = props.pattern;
  React.useEffect(function () {
    var patternGraph = new G6.Graph({
      container: 'gi-pattern-match-graph-container',
      width: 380,
      height: 250,
      fitView: true,
      defaultEdge: {
        size: 2,
        style: {
          endArrow: {
            path: G6.Arrow.triangle(10, 10)
          }
        },
        labelCfg: {
          autoRotate: true,
          style: {
            stroke: '#fff',
            lineWidth: 2
          }
        }
      },
      defaultNode: {
        labelCfg: {
          position: 'right'
        }
      },
      layout: {
        type: 'dagre',
        ranksep: 20
      }
    });
    var clonePattern = JSON.parse(JSON.stringify(pattern));
    patternGraph.data(clonePattern);
    patternGraph.render();
    return function () {
      patternGraph.destroy();
    };
  }, [pattern]);
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
    id: "gi-pattern-match-graph-container"
  }));
};
export default PatternGraph;