"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _graphin = require("@antv/graphin");
var React = _interopRequireWildcard(require("react"));
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var PatternGraph = function PatternGraph(props) {
  var pattern = props.pattern;
  React.useEffect(function () {
    var patternGraph = new _graphin.G6.Graph({
      container: 'gi-pattern-match-graph-container',
      width: 380,
      height: 250,
      fitView: true,
      defaultEdge: {
        size: 2,
        style: {
          endArrow: {
            path: _graphin.G6.Arrow.triangle(10, 10)
          }
        },
        labelCfg: {
          autoRotate: true,
          style: {
            stroke: '#fff',
            lineWidth: 2
          }
        }
      },
      defaultNode: {
        labelCfg: {
          position: 'right'
        }
      },
      layout: {
        type: 'dagre',
        ranksep: 20
      }
    });
    var clonePattern = JSON.parse(JSON.stringify(pattern));
    patternGraph.data(clonePattern);
    patternGraph.render();
    return function () {
      patternGraph.destroy();
    };
  }, [pattern]);
  return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", {
    id: "gi-pattern-match-graph-container"
  }));
};
var _default = PatternGraph;
exports.default = _default;