"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _globalLocale = _interopRequireDefault(require("@aligov/global-locale"));
var _globalStringFormat = _interopRequireDefault(require("@aligov/global-string-format"));
var _strings = _interopRequireDefault(require("./strings"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var language; // Current language
var intl; // Instance of intl-universal. Create by provideIntl
/**
 * update instance of intl universal
 */
function update() {
  var _locale$getLocale = _globalLocale.default.getLocale(),
    lang = _locale$getLocale.lang;
  language = lang;
  intl = _globalStringFormat.default.init(lang, _strings.default);
}
/**
 * change current language
 * @param {string} langTag language tag config above
 */
function change(langTag) {
  _globalLocale.default.setLang(langTag);
  update();
}
/**
 * Format string by key
 * For example:
 * $i18n.get('jsx.home.title'),
 * $i18n.get({
 *    id: 'jsx.home.hello',
 *    defaultMessage: 'Hello {name}' // not required
 * },{
 *  name: 'Alice'
 * })
 * More syntax: https://formatjs.io/guides/message-syntax/
 * @param {string|object} id key or object
 * @param {object} variable variable for id
 * @return {string} format message
 */
function get(id) {
  var variable = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  if (!intl) update();
  if (typeof id === 'string') {
    return _globalStringFormat.default.format({
      id: id
    }, variable);
  } else if (_typeof(id) === 'object' && id.dm) {
    id.defaultMessage = id.dm;
  }
  return _globalStringFormat.default.format({
    id: id.id,
    defaultString: id.dm
  }, variable);
}
var _default = {
  get: get,
  update: update,
  change: change,
  language: language
};
exports.default = _default;